#include <XY.h>
#include <Wire.h>
#include <LCD03.h>
#include <Streaming.h>
#include <Metro.h>
#include <PID.h>

// LCD and LCD scheduler instantiation
LCD03 lcd;
Metro metroLCD = Metro(200);
// dip coater instantiation
int SampleTime = 100;
Metro metroDipCoater = Metro(SampleTime);
XY dipcoater(SampleTime);
// scheduler instantiation
Metro metroScheduler = Metro(20000);
Metro metroCounter = Metro(1000);

void setup()
{
  //Serial.begin(9600);
  //Serial.println("asd");
  
  lcd.begin(20, 4);
  lcd.backlight();
  lcd.clear();
  
  //analogReference(EXTERNAL);
  
  randomSeed(analogRead(3));
}

void loop()
{
    
  // get input to control dip coater
  if (metroScheduler.check() == 1)
  {
    // make random moves around the whole range:
    dipcoater.setXcm(random(0, TRAVERSE_X));
    dipcoater.setYcm(random(0, TRAVERSE_Y));
  }
  
  // run control loop
  if (metroDipCoater.check() == 1)
  {
    DipCoaterState = dipcoater.check();
  }
  
  // print output to LCD
  if (metroLCD.check() == 1)
  {
    lcd.clear();
    lcd.setCursor(0,0);
    lcd << "Test program";
    lcd.setCursor(0,1);
    lcd << "X:" << _FLOAT(dipcoater.getInputX(),0) << "/" << _FLOAT(dipcoater.getSetpointX(),0) <<
      " Y:" << _FLOAT(dipcoater.getInputY(),0) << "/" << _FLOAT(dipcoater.getSetpointY(),0);
    lcd.setCursor(0,2);
    lcd << dipcoater.getOutputX() << " " << dipcoater.getOutputY();
  }
}


